<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 03/12/2014
 * Time: 09:03
 */

namespace Folha\Logic\Exame;


use Folha\Entities\SstPerfilexameocupacao;
use Folha\Entities\SstPerfilexamevinculo;
use Geral\Util\Ambiente;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class PerfilExame {
    public static function cadastraPerfis($params, $ocupacoes, $paramAux)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = Registry::getEntityManager();
        $cadastrados = array();

        try{
            foreach($ocupacoes as $ocupacao) {
                //A busca vinda do repositório retorna a posição do array com caracteres maiúsculos,
                //já a busca feita pelo reference multisearch retorna com caracteres minúsculos.
                if($paramAux) {
                    $nrOcupacaom = $ocupacao['NROCUPACAOM'];
                    $nmOcupacaoh = $ocupacao['NMOCUPACAOH'];
                } else {
                    $nrOcupacaom = $ocupacao['nrocupacaom'];
                    $nmOcupacaoh = $ocupacao['nmocupacaoh'];
                }

                $validaOcup = SstPerfilexameocupacao::findOneByNrocupacaomAndNrperfilexameAndNrorg($nrOcupacaom, $params['NRPERFILEXAME'], $params['NRORG']);

                if(!is_object($validaOcup)) {
                    $perfil = new SstPerfilexameocupacao();
                    $perfil->setNrperfilexameocupacao(NovoCodigo::geraCodigo(Ambiente::getNrorg(), 'SST_PERFILEXAMEOCUPACAO', 1));
                    $perfil->setNrperfilexame($params['NRPERFILEXAME']);
                    $perfil->setNrocupacaom($nrOcupacaom);
                    $perfil->setDtinivigencia($params['DTINIVIGENCIA']);
                    $perfil->setNrorg($params['NRORG']);
                    $perfil->setNrorginclusao($params['NRORG']);
                    $perfil->setNrorgultatu($params['NRORG']);
                    $perfil->setDtinclusao($params['DATA_ATUAL']);
                    $perfil->setDtultatu($params['DATA_ATUAL']);
                    $perfil->setCdoperinclusao($params['CDOPERADOR']);
                    $perfil->setCdoperultatu($params['CDOPERADOR']);

                    if($params['DTFIMVIGENCIA'] != '') {
                        $perfil->setDtfimvigencia($params['DTFIMVIGENCIA']);
                    }

                    $perfil->persist();
                } else {
                    $cadastrados[] = $nmOcupacaoh;
                    sort($cadastrados);
                }
            }

            $connection->flush();
            $db->getConn()->commit();

            return $cadastrados;
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function cadastraPerfisVinculo($dados)
    {
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();

        try {
            foreach($dados['VINCULOS'] as $vinculo) {
                $perfilVinc = new SstPerfilexamevinculo();
                $perfilVinc->setNrperfilexamevinculo(NovoCodigo::geraCodigo($dados['NRORG'], 'SST_PERFILEXAMEVINCULO', 1));
                $perfilVinc->setDtinivigencia($dados['DTINIVIGENCIA']);
                $perfilVinc->setNrperfilexame($dados['NRPERFILEXAME']);
                $perfilVinc->setNrvinculom($vinculo['NRVINCULOM']);
                $perfilVinc->setIdativo('S');
                $perfilVinc->setNrorg($dados['NRORG']);
                $perfilVinc->setNrorginclusao($dados['NRORG']);
                $perfilVinc->setNrorgultatu($dados['NRORG']);
                $perfilVinc->setCdoperinclusao($dados['CDOPERADOR']);
                $perfilVinc->setCdoperultatu($dados['CDOPERADOR']);
                $perfilVinc->setDtinclusao($dados['DATA_ATUAL']);
                $perfilVinc->setDtultatu($dados['DATA_ATUAL']);

                if($dados['DTFIMVIGENCIA'] != '') {
                    $perfilVinc->setDtfimvigencia($dados['DTFIMVIGENCIA']);
                }

                $perfilVinc->persist();
            }

            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }
    }
} 