package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.annotations.Test;

public class PontoDeEntregaPage extends PageBase {

    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicarBotaoParametrizacao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");
    By clicarBotaoPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");
    By clicarPontoDeEntrega = By.xpath("//*[contains(text(),'Ponto de Entrega')]");
    By btnAdicionaPonto = By.xpath("//*[@id='footer']/div[2]/ul/li[1]");
    By limpaFiltroFilial = By.xpath("//div[@id = 'FILTER_FILIAL']");
    By filtroFilial = By.xpath("//div[@id = 'FILTER_FILIAL']/span");
    By inputUnidade = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaUnidade = By.xpath("//*[@id='grid-9000']/div[2]/div/div");
    By codigoPontoEntrega = By.xpath("//input[@id='CDDESTFILI']");
    By nomePontoEntrega = By.xpath("//input[@id='NMDESTFILI']");
    By endePontoEntrega = By.xpath("//input[@id='DSENDEDESTFILI']");
    By btnSalvar = By.xpath("//*[@id='footer']/div[3]/ul/li");
    By validaRegistro = By.xpath("//span[contains(text(),'002')]");

    By clicaNomePontoEntrega = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[2]/div");
    By novoNomePontoEntrega = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[2]/div/input");
    By campoEndereco = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[3]/div");
    By novoEndereco = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]/div[3]/div/input");
    By btnSalvarAlteracao = By.xpath("//*[text() = 'Salvar alterações']");
    By clicaRegistro = By.xpath("//span[contains(text(),'001')]");
    By btnExcluirPonto = By.xpath("//*[@id='footer']/div[2]/ul/li[2]");
    By confirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[contains(text(),'Sim')]");
    By btnOk = By.xpath("//button[@class = 'zh-alert-button']");
    By clicarRegistroExclusao = By.xpath("//*[@id='grid-7299881293547190374476']/div[2]/div/div[2]");


    public void navegaPontoDeEntrega(){
        waitForElement(clicaMenu);
        waitForElement(usernameLoginInfoTextArea);
        click(clicaMenu);
        tempo();
        click(clicarBotaoParametrizacao);
        tempo();
        click(clicarBotaoPlanejamento);
        tempo();
        click(clicarPontoDeEntrega);
        tempo();


    }

    public void dadosPontoEntrega(String CDFILIAL, String CDPONTOENTREGA, String NMPONTOENTREGA, String ENDEPONTOENTREGA){
    click(limpaFiltroFilial);
    tempo();
    click(filtroFilial);
    tempo();
    click(inputUnidade);
    sendKeys(inputUnidade, CDFILIAL);
    tempo();
    click(selecionaUnidade);
    tempo();
    click(btnAdicionaPonto);
    tempo();
    click(codigoPontoEntrega);
    sendKeys(codigoPontoEntrega,CDPONTOENTREGA);
    tempo();
    click(nomePontoEntrega);
    sendKeys(nomePontoEntrega, NMPONTOENTREGA);
    tempo();
    click(endePontoEntrega);
    sendKeys(endePontoEntrega,ENDEPONTOENTREGA);
    tempo();
    click(btnSalvar);
    tempo();
    }

    public String validaCadastro(){
        return getText(validaRegistro);

    }

    public void alteraPontoDeEntrega(){
        click(clicaNomePontoEntrega);
        click(novoNomePontoEntrega);
        clearAndSendKeys(novoNomePontoEntrega,"THIAGO");
        tempo();
        click(campoEndereco);
        click(novoEndereco);
        clearAndSendKeys(novoEndereco,"AVENIDA DAS AMÉRICAS, 200");
        click(btnSalvarAlteracao);
        tempo();

    }

    public void apagaPontoDeEntrega(){
        click(clicaRegistro);
        tempo();
        click(btnExcluirPonto);
        tempo();
        click(confirmaExclusao);
        tempo();
        click(btnOk);
        tempo();
        click(clicarRegistroExclusao);
        tempo();
        click(btnExcluirPonto);
        tempo();
        click(confirmaExclusao);
        tempo();
    }

}
